//=======================================================================================
//  HID MOUSE , ͬ USB 豸, һ
//=======================================================================================
#include  "USB_define.h"

#define  USB_VID		               0x0416
#define  USB_PID		               0x5020

#define  DESC_DEVICE               0x01                    // USBЭ鶨ļ
#define  DESC_CONFIG               0x02
#define  DESC_STRING               0x03
#define  DESC_INTERFACE            0x04
#define  DESC_ENDPOINT             0x05
#define  DESC_QUALIFIER            0x06
#define  DESC_OTHERSPEED           0x07
#define  DESC_HID                  0x21                    // HID Descriptor Type 
#define  DESC_HID_RPT              0x22                    // HID Report Type 

#define  LEN_DEVICE                18                      // USBЭ鶨豸
#define  LEN_CONFIG                9                       // 
#define	 LEN_INTERFACE             9                       // ӿ
#define	 LEN_ENDPOINT              7                       // ˵
#define LEN_HID                    9

#define  EP_INPUT                  0x80                    // ˵ֽ2"λ"
#define  EP_OUTPUT                 0x00

#define  EP_CTL                    0x00                    // ˵ֽ3Ķ˵
#define  EP_ISO                    0x01
#define  EP_BULK                   0x02                  
#define  EP_INT                    0x03

unsigned char const HID_DeviceReportDescriptor[] =
{
    0x05, 0x01,            // USAGE_PAGE (Generic Desktop)
    0x09, 0x00,            // USAGE (0)
    0xA1, 0x01,            // COLLECTION (Application)
    0x15, 0x00,            // LOGICAL_MINIMUM (0)
    0x25, 0xFF,            // LOGICAL_MAXIMUM (255)
    0x19, 0x01,            // USAGE_MINIMUM (1)
    0x29, 0x08,            // USAGE_MAXIMUM (8)
    0x95, 0x40,            // REPORT_COUNT (8)
    0x75, 0x08,            // REPORT_SIZE (8)
    0x81, 0x02,            // INPUT (Data,Var,Abs)
    0x19, 0x01,            // USAGE_MINIMUM (1)
    0x29, 0x08,            // USAGE_MAXIMUM (8)
    0x91, 0x02,            // OUTPUT (Data,Var,Abs)
    0xC0                   // END_COLLECTION
};

unsigned char const USB_DeviceDescriptor[] =
{
    LEN_DEVICE,     /* bLength */
    DESC_DEVICE,    /* bDescriptorType */
    0x10, 0x01,     /* bcdUSB */
    0x00,           /* bDeviceClass */
    0x00,           /* bDeviceSubClass */
    0x00,           /* bDeviceProtocol */
    USB_EP0_PACKET_SIZE,   /* bMaxPacketSize0 */
    /* idVendor */
    USB_VID & 0x00FF,
    (USB_VID & 0xFF00) >> 8,
    /* idProduct */
    USB_PID & 0x00FF,
    (USB_PID & 0xFF00) >> 8,
    0x00, 0x00,     /* bcdDevice */
    0x01,           /* iManufacture */
    0x02,           /* iProduct */
    0x00,           /* iSerialNumber - no serial */
    0x01            /* bNumConfigurations */
};

unsigned char const USB_ConfigDescriptor[] =
{
    LEN_CONFIG,     /* bLength */
    DESC_CONFIG,    /* bDescriptorType */
    /* wTotalLength */
    41,   0,
    0x01,           /* bNumInterfaces */
    0x01,           /* bConfigurationValue */
    0x00,           /* iConfiguration */
    0x80,           /* bmAttributes */
    50,         /* MaxPower */

    /* I/F descr: HID */
    LEN_INTERFACE,  /* bLength */
    DESC_INTERFACE, /* bDescriptorType */
    0x00,           /* bInterfaceNumber */
    0x00,           /* bAlternateSetting */
    0x02,           /* bNumEndpoints */
    0x03,           /* bInterfaceClass */
    0,           /* bInterfaceSubClass */
    0,              /* bInterfaceProtocol */
    0,           /* iInterface */

    /* HID Descriptor */
    LEN_HID,        /* Size of this descriptor in UINT8s. */
    DESC_HID,       /* HID descriptor type. */
    0x10, 0x01,     /* HID Class Spec. release number. */
    0x00,           /* H/W target country. */
    0x01,           /* Number of HID class descriptors to follow. */
    DESC_HID_RPT,   /* Dscriptor type. */
    /* Total length of report descriptor. */
    sizeof(HID_DeviceReportDescriptor) & 0x00FF,
    (sizeof(HID_DeviceReportDescriptor) & 0xFF00) >> 8,

    /* EP Descriptor: interrupt in. */
    LEN_ENDPOINT,   /* bLength */
    DESC_ENDPOINT,  /* bDescriptorType */
    (INT_IN_EP_NUM | EP_INPUT), /* bEndpointAddress */
    EP_INT,         /* bmAttributes */
    /* wMaxPacketSize */
    USB_PACKET_SIZE & 0x00FF,
    (USB_PACKET_SIZE & 0xFF00) >> 8,
    1,                    /* bInterval */
    
    LEN_ENDPOINT,   /* bLength */
    DESC_ENDPOINT,  /* bDescriptorType */
    (INT_OUT_EP_NUM | EP_OUTPUT),   /* bEndpointAddress */
    EP_INT,         /* bmAttributes */
    /* wMaxPacketSize */
    USB_PACKET_SIZE & 0x00FF,
    (USB_PACKET_SIZE & 0xFF00) >> 8,
    1     /* bInterval */
};

unsigned char const USB_StringLang[4] =
{
  4,              /* bLength */
  DESC_STRING,    /* bDescriptorType */
  0x09, 0x04
};

unsigned char const USB_ProductStringDesc[] =
{
  32, DESC_STRING,
  'N', 0, 
  'U', 0, 
  'C', 0, 
  '1', 0, 
  '2', 0, 
  '3', 0, 
  '_', 0, 
  'T', 0, 
  'r', 0,
  'a', 0,
  'n', 0,
  's', 0,
  'f', 0,
  'e', 0,
  'r', 0
};
